{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
osCommerce Product Manager for Windows (oscpmwin).
Copyright 2003,2004,2005 by Mario A. Valdez-Ramirez.

You can contact Mario A. Valdez-Ramirez
by email at mario@mariovaldez.org or paper mail at
Olmos 809, San Nicolas, NL. 66495, Mexico.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or (at
your option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
unit pedit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, Buttons, ExtCtrls,
  ImgList, Menus, ShellAPI, CheckLst, oscpmdata;

CONST
  OPM_AUTODOWNLOADIMG = WM_USER + 1234;

type
  Topm_Form_PEdit = class(TForm)
    opm_BitBtn_PEditOk: TBitBtn;
    opm_BitBtn_PEditCancel: TBitBtn;
    opm_ImageList_PImg: TImageList;
    opm_PageControl_PEdit: TPageControl;
    opm_TabSheet_PEditMain: TTabSheet;
    opm_TabSheet_PEditDesc: TTabSheet;
    opm_ComboBox_PEditCat: TComboBox;
    opm_ComboBox_PEditMan: TComboBox;
    opm_Edit_PEditModel: TEdit;
    opm_Edit_PEditQuantity: TEdit;
    opm_Edit_PEditPrice: TEdit;
    opm_Edit_PEditSpecial: TEdit;
    opm_Edit_PEditWeight: TEdit;
    opm_label_PeditWeight: TLabel;
    opm_label_PeditSpecial: TLabel;
    opm_label_PeditPrice: TLabel;
    opm_label_PeditQty: TLabel;
    opm_label_PeditModel: TLabel;
    opm_label_PeditMan: TLabel;
    opm_label_PeditCat: TLabel;
    opm_CheckBox_PEditAvailable: TCheckBox;
    opm_TabControl_PEdit: TTabControl;
    opm_label_PeditName: TLabel;
    opm_label_PeditDesc: TLabel;
    opm_label_PeditURL: TLabel;
    opm_Edit_PEditName: TEdit;
    opm_Memo_PEditDescription: TMemo;
    opm_Edit_PEditURL: TEdit;
    opm_ComboBox_PEditTax: TComboBox;
    opm_label_PeditTax: TLabel;
    opm_TabSheet_PEditImg: TTabSheet;
    opm_Panel_PeditImage: TPanel;
    opm_Image_Pedit: TImage;
    opm_label_PeditDown: TLabel;
    opm_ProgressBar_Pedit: TProgressBar;
    opm_BitBtn_PEditStopDown: TBitBtn;
    opm_StaticText_PeditImageETA: TStaticText;
    opm_StaticText_PeditImageData: TStaticText;
    opm_StaticText_PeditImageURL: TStaticText;
    opm_BitBtn_PEditDown: TBitBtn;
    opm_BitBtn_PEditDeleteImg: TBitBtn;
    opm_BitBtn_PEditUploadImg: TBitBtn;
    opm_StaticText_PeditCurr1: TStaticText;
    opm_StaticText_PeditCurr2: TStaticText;
    opm_Label_PeditViewed: TLabel;
    opm_StaticText_PeditViewed: TStaticText;
    opm_Memo_UploadDEBUG: TMemo;
    opm_PopupMenu_UploadDebug: TPopupMenu;
    opm_PopMenuItem_HideUploadDebug: TMenuItem;
    opm_BitBtn_PEditSelectImg: TBitBtn;
    opm_BitBtn_PEditStripHTML: TBitBtn;
    opm_DateTimePicker_PEditAvailDate: TDateTimePicker;
    opm_label_PeditAvailDate: TLabel;
    opm_StaticText_PeditCDate: TStaticText;
    opm_StaticText_PeditMDate: TStaticText;
    opm_label_PeditCDate: TLabel;
    opm_label_PeditMDate: TLabel;
    opm_label_PeditPriceTaxed: TLabel;
    opm_Edit_PEditPriceTaxed: TEdit;
    opm_StaticText_PeditCurr3: TStaticText;
    StatusBar1: TStatusBar;
    procedure FormShow(Sender: TObject);
    procedure opm_BitBtn_PEditOkClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure opm_BitBtn_PEditDownClick(Sender: TObject);
    procedure opm_BitBtn_PEditStopDownClick(Sender: TObject);
    procedure opm_Image_PeditClick(Sender: TObject);
    procedure opm_BitBtn_PEditDeleteImgClick(Sender: TObject);
    procedure opm_BitBtn_PEditUploadImgClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure opm_BitBtn_PEditSelectImgClick(Sender: TObject);
    procedure opm_PopMenuItem_HideUploadDebugClick(Sender: TObject);
    procedure opm_TabControl_PEditChange(Sender: TObject);
    procedure opm_TabControl_PEditChanging(Sender: TObject; var AllowChange: Boolean);
    procedure opm_BitBtn_PEditStripHTMLClick(Sender: TObject);
    procedure opm_ComboBox_PEditTaxChange(Sender: TObject);
    procedure opm_Edit_PEditPriceChange(Sender: TObject);
    procedure opm_Edit_PEditPriceTaxedChange(Sender: TObject);
    procedure opm_Edit_PEditPriceTaxedExit(Sender: TObject);
    procedure opm_Edit_PEditPriceTaxedEnter(Sender: TObject);
    procedure opm_Edit_PEditPriceEnter(Sender: TObject);
    procedure opm_Edit_PEditPriceExit(Sender: TObject);
  private
    PROCEDURE opm_PRDownload_Image (ImgURL : STRING);
    PROCEDURE opm_PRSetControls (ImageName : STRING; ImageState : WORD; ClearThumb: BOOLEAN);
    PROCEDURE opm_PRPrepareUpload (ImageFile, NewName, ImgSubdir : STRING; ImageJPEG : BOOLEAN);
    FUNCTION opm_FNCleanURL (ProductURL : STRING) : STRING;
    FUNCTION FNopm_GetTax (VAR TaxList : opmT_TaxList; TaxID : LONGINT; SearchBy : INTEGER) : opmR_Tax;
  public
    procedure AutoDownload (var DownloadMsg: TMessage); message OPM_AUTODOWNLOADIMG;
    procedure GetDropFiles (var DropingMsg: TWMDropFiles); message WM_DROPFILES;
  end;

var
  opm_Form_PEdit: Topm_Form_PEdit;
  opm_PEdit_CanZoom : BOOLEAN;
  opm_CurrentImage : STRING;
  opm_PEdit_CanClose : BOOLEAN;
  opm_PEdit_CalcNewTax : BOOLEAN;
  opm_PEdit_CalcTaxed : BOOLEAN;
  opm_PEdit_CalcUnTaxed : BOOLEAN;

implementation

{$R *.dfm}

uses gnugettext, main, pimgzoom, balloons, dataman, attention, imageman,
     askupload, askuser, regconfig, network;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_PEdit.opm_PRSetControls (ImageName : STRING; ImageState : WORD; ClearThumb: BOOLEAN);
BEGIN
  opm_Panel_PeditImage.Caption := ImageName;
  opm_Panel_PeditImage.Hint := ImageName;
  FNballoon_UpdateBalloon (PCHAR (ImageName), 0, opm_Panel_PeditImage.Handle, opm_Form_PEdit);
  opm_StaticText_PeditImageURL.Caption := ImageName;
  IF (ClearThumb = TRUE) THEN
    BEGIN
      opm_Image_Pedit.Picture := NIL;
      opm_Form_ImageZoom.opm_Image_ZoomImage.Picture := NIL;
    END;
  IF (ImageName = '') THEN ImageState := opmC_ImageIsEmpty;
  CASE ImageState OF
    opmC_ImageDontExist :
      BEGIN
        opm_PEdit_CanZoom := FALSE;
        opm_StaticText_PeditImageData.Caption := '';
        opm_StaticText_PeditImageETA.Caption := '';
        opm_ImageList_PImg.GetBitmap (2, opm_Image_Pedit.Picture.Bitmap);
        opm_Image_Pedit.Cursor := crDefault;
        opm_BitBtn_PEditDown.Enabled := TRUE;
        opm_BitBtn_PEditDeleteImg.Enabled := TRUE;
        opm_BitBtn_PEditUploadImg.Enabled := FALSE;
        opm_BitBtn_PEditSelectImg.Enabled := FALSE;
      END;
    opmC_ImageMayExist :
      BEGIN
        opm_PEdit_CanZoom := FALSE;
        opm_StaticText_PeditImageData.Caption := '';
        opm_StaticText_PeditImageETA.Caption := '';
        opm_Image_Pedit.Cursor := crDefault;
        opm_BitBtn_PEditDown.Enabled := TRUE;
        opm_BitBtn_PEditDeleteImg.Enabled := TRUE;
        opm_BitBtn_PEditUploadImg.Enabled := FALSE;
        opm_BitBtn_PEditSelectImg.Enabled := FALSE;
      END;
    opmC_ImageExists :
      BEGIN
        opm_PEdit_CanZoom := TRUE;
        opm_Image_Pedit.Cursor := crHandPoint;
        opm_BitBtn_PEditDown.Enabled := TRUE;
        opm_BitBtn_PEditDeleteImg.Enabled := TRUE;
        opm_BitBtn_PEditUploadImg.Enabled := FALSE;
        opm_BitBtn_PEditSelectImg.Enabled := FALSE;
      END;
    opmC_ImageIsEmpty :
      BEGIN
        opm_PEdit_CanZoom := FALSE;
        opm_StaticText_PeditImageData.Caption := '';
        opm_StaticText_PeditImageETA.Caption := '';
        opm_ImageList_PImg.GetBitmap (0, opm_Image_Pedit.Picture.Bitmap);
        opm_Image_Pedit.Cursor := crDefault;
        opm_BitBtn_PEditDown.Enabled := FALSE;
        opm_BitBtn_PEditDeleteImg.Enabled := FALSE;
        opm_BitBtn_PEditUploadImg.Enabled := TRUE;
        opm_BitBtn_PEditSelectImg.Enabled := TRUE;
      END;
    opmC_ImageIsCorrupt :
      BEGIN
        opm_PEdit_CanZoom := FALSE;
        opm_StaticText_PeditImageData.Caption := '';
        opm_StaticText_PeditImageETA.Caption := '';
        opm_Image_Pedit.Cursor := crDefault;
        opm_BitBtn_PEditDeleteImg.Enabled := TRUE;
        opm_BitBtn_PEditDown.Enabled := TRUE;
        opm_BitBtn_PEditUploadImg.Enabled := FALSE;
        opm_BitBtn_PEditSelectImg.Enabled := FALSE;
        opm_ImageList_PImg.GetBitmap (1, opm_Image_Pedit.Picture.Bitmap);
      END;
    opmC_ImageIsBeingProcessed :
      BEGIN
        opm_PEdit_CanZoom := FALSE;
        opm_Image_Pedit.Cursor := crDefault;
        opm_BitBtn_PEditDown.Enabled := FALSE;
        opm_BitBtn_PEditDeleteImg.Enabled := FALSE;
        opm_BitBtn_PEditUploadImg.Enabled := FALSE;
        opm_BitBtn_PEditSelectImg.Enabled := FALSE;
      END;
  END;
  IF (opmG_WBUploadURL = '') THEN
    BEGIN
      opm_BitBtn_PEditDeleteImg.Enabled := FALSE;
      opm_BitBtn_PEditUploadImg.Enabled := FALSE;
      opm_BitBtn_PEditSelectImg.Enabled := FALSE;
    END;
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_PEdit.FormShow(Sender: TObject);
VAR
  CurLang : LONGINT;
  DisplayTabIndex : LONGINT;
  CurCat : opmR_Category;
begin
  opm_PEdit_CalcNewTax := FALSE;
  opm_PEdit_CalcTaxed := FALSE;
  opm_PEdit_CalcUnTaxed := FALSE;
  opm_Form_PEdit.Caption := opm_CurrentProdRecord.DisplayName;
  opm_Edit_PEditModel.Text := opm_CurrentProdRecord.Model;
  opm_ComboBox_PEditMan.Items := opmG_ManufacturerBoxList;
  opm_ComboBox_PEditTax.Items := opmG_TaxBoxList;
  opm_CurrentManRecord := opm_Form_Main.FNopm_GetManufacturer (opmG_ManufacturerList, opm_CurrentProdRecord.ManufacturerID, opmC_FindByID);
  opm_ComboBox_PEditMan.ItemIndex := opm_CurrentManRecord.ListIndex;
  opm_CurrentTaxRecord := FNopm_GetTax (opmG_TaxList, opm_CurrentProdRecord.Tax, opmC_FindByID);
  opm_ComboBox_PEditTax.ItemIndex := opm_CurrentTaxRecord.ListIndex;
  opm_ComboBox_PEditCat.Items := opmG_CategoryBoxList;
  {opm_CheckListBox_PEditCat.Items := opmG_CategoryBoxList;}
  CurCat := opm_Form_Main.FNopm_GetCategory (opmG_CategoryList, opm_CurrentProdRecord.CategoryID, opmC_FindByID);
  opm_ComboBox_PEditCat.ItemIndex := CurCat.ListIndex;
  opm_Edit_PEditQuantity.Text := INTTOSTR (opm_CurrentProdRecord.Quantity);
  opm_Edit_PEditPrice.Text := CURRTOSTR (opm_CurrentProdRecord.Price);
  opm_Edit_PEditPriceTaxed.Text := FNopm_AfterTaxPrice (opm_Edit_PEditPrice.Text, opm_CurrentTaxRecord.SumRate);
  opm_Edit_PEditSpecial.Text := CURRTOSTR (opm_CurrentProdRecord.Special);
  opm_Edit_PEditWeight.Text := FLOATTOSTR (opm_CurrentProdRecord.Weight);
  IF (opmG_UIAutoDownImg = 0) THEN opm_PageControl_PEdit.ActivePageIndex := 0 ELSE opm_PageControl_PEdit.ActivePageIndex := (opm_PageControl_PEdit.PageCount - 1);
  opm_TabControl_PEdit.Tabs.Clear;
  opm_TabControl_PEdit.Tabs := opmG_LanguageBoxList;
  DisplayTabIndex := opmC_Def_DisplayLang;
  FOR CurLang := 0 TO (opm_TotalLanguages - 1) DO
    IF (opm_CurrentLang = opmG_LanguageList[CurLang].ID) THEN DisplayTabIndex := CurLang;
  opm_TabControl_PEdit.TabIndex := DisplayTabIndex;
  IF (opm_CurrentProdRecord.Available > 0) THEN opm_CheckBox_PEditAvailable.Checked := TRUE ELSE opm_CheckBox_PEditAvailable.Checked := FALSE;
  opm_StaticText_PeditCDate.Caption := FNopm_DateToString (opm_CurrentProdRecord.CreationDate);
  opm_StaticText_PeditMDate.Caption := FNopm_DateToString (opm_CurrentProdRecord.ChangeDate);
  opm_DateTimePicker_PEditAvailDate.DateTime := opm_CurrentProdRecord.AvailDate;
  opm_StaticText_PeditCurr1.Caption := opm_CurrentCurrency.Code + ' ' + opm_CurrentCurrency.Left + ' ' + opm_CurrentCurrency.Right;
  opm_StaticText_PeditCurr2.Caption := opm_CurrentCurrency.Code + ' ' + opm_CurrentCurrency.Left + ' ' + opm_CurrentCurrency.Right;
  opm_StaticText_PeditCurr3.Caption := opm_CurrentCurrency.Code + ' ' + opm_CurrentCurrency.Left + ' ' + opm_CurrentCurrency.Right;
  opm_Edit_PEditName.Text := opm_CurrentSingleDescList[DisplayTabIndex].Name;
  opm_Edit_PEditURL.Text := opm_FNCleanURL (opm_CurrentSingleDescList[DisplayTabIndex].URL);
  opm_StaticText_PeditViewed.Caption := INTTOSTR (opm_CurrentSingleDescList[DisplayTabIndex].Viewed);
  opm_Memo_PEditDescription.Lines.Text := opm_CurrentSingleDescList[DisplayTabIndex].Description;
  opm_ProgressBar_Pedit.Enabled := FALSE;
  opm_ProgressBar_Pedit.Min := 0;
  opm_ProgressBar_Pedit.Max := 100;
  opm_ProgressBar_Pedit.Position := 0;
  opm_label_PeditDown.Caption := '';
  opm_BitBtn_PEditStopDown.Visible := FALSE;
  opm_BitBtn_PEditStopDown.Enabled := FALSE;
  opm_Memo_UploadDEBUG.Clear;
  opm_CurrentImage := opm_CurrentProdRecord.ImageURL;
  opm_PRSetControls (opm_CurrentImage, opmC_ImageMayExist, TRUE);
  opm_PEdit_CanClose := TRUE;
  PRopm_Prepare_HTTPClient (opm_ProgressBar_Pedit, opm_label_PeditDown); { ASSIGN THE DOWNLOAD VISUAL-FEEDBACK CONTROLS... }
  DragAcceptFiles (Handle, TRUE);
  IF (opmG_UIAutoDownImg > 0) THEN PostMessage (Handle, OPM_AUTODOWNLOADIMG, 0, LONGINT (Sender));
  opm_PEdit_CalcNewTax := TRUE;
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_PEdit.opm_BitBtn_PEditOkClick(Sender: TObject);
VAR
  CurMan : opmR_Manufacturer;
  CurCat : opmR_Category;
  CurTax : opmR_Tax;
  CurLang : LONGINT;
begin
  opm_CurrentPEditRecord.ID := opm_CurrentProdRecord.ID;
  opm_CurrentPEditRecord.Model := FNopm_CleanString (opm_Edit_PEditModel.Text);
  opm_CurrentPEditRecord.Quantity := STRTOINT (FNopm_CleanNumber (opm_Edit_PEditQuantity.Text, opmC_ValIsInteger));
  CurMan := opm_Form_Main.FNopm_GetManufacturer (opmG_ManufacturerList, opm_ComboBox_PEditMan.ItemIndex, opmC_FindByIndex);
  opm_CurrentPEditRecord.ManufacturerID := CurMan.ID;
  CurTax := FNopm_GetTax (opmG_TaxList, opm_ComboBox_PEditTax.ItemIndex, opmC_FindByIndex);
  opm_CurrentPEditRecord.Tax := CurTax.ID;
  CurCat := opm_Form_Main.FNopm_GetCategory (opmG_CategoryList, opm_ComboBox_PEditCat.ItemIndex, opmC_FindByIndex);
  opm_CurrentPEditRecord.CategoryID := CurCat.ID;
  opm_CurrentPEditRecord.Price := ABS (STRTOCURR (FNopm_CleanNumber (opm_Edit_PEditPrice.Text, opmC_ValIsFloat)));
  opm_CurrentPEditRecord.Special := ABS (STRTOCURR (FNopm_CleanNumber (opm_Edit_PEditSpecial.Text, opmC_ValIsFloat)));
  opm_CurrentPEditRecord.Weight := ABS (STRTOFLOAT (FNopm_CleanNumber (opm_Edit_PEditWeight.Text, opmC_ValIsFloat)));
  opm_CurrentPEditRecord.DisplayName := FNopm_CleanString (opm_Edit_PEditName.Text);
  opm_CurrentPEditRecord.ImageURL := opm_CurrentImage;
  opm_CurrentPEditRecord.LanguageID := opm_CurrentLang;
  opm_CurrentPEditRecord.AvailDate := opm_DateTimePicker_PEditAvailDate.DateTime;
  IF (opm_CheckBox_PEditAvailable.Checked = TRUE) THEN opm_CurrentPEditRecord.Available := 1 ELSE opm_CurrentPEditRecord.Available := 0;
  opm_CurrentSingleDescList[opm_TabControl_PEdit.TabIndex].Name := FNopm_CleanString (opm_Edit_PEditName.Text);
  opm_CurrentSingleDescList[opm_TabControl_PEdit.TabIndex].URL := opm_FNCleanURL (opm_Edit_PEditURL.Text);
  opm_CurrentSingleDescList[opm_TabControl_PEdit.TabIndex].Description := FNopm_CleanString (opm_Memo_PEditDescription.Lines.Text);
  FOR CurLang := 0 TO (opm_TotalLanguages - 1) DO
    IF (opm_CurrentSingleDescList[CurLang].ID > 0) THEN
      BEGIN
        IF (opm_CurrentSingleDescList[CurLang].Name = '') THEN
          BEGIN
            opm_PageControl_PEdit.ActivePageIndex := 1;
            opm_Form_PEdit.FocusControl (opm_Edit_PEditName);
            FNopm_Message (_('The name of the product is missing.'), mtWarning, [mbOk], opmG_UISilent);
            ModalResult := mrNone;
            BREAK;
          END;
      END;
IF ((opm_CurrentPEditRecord.Quantity < 0) AND (opmG_UIAllowNegativeQuantity = 0)) THEN
    BEGIN
      opm_PageControl_PEdit.ActivePageIndex := 0;
      opm_Form_PEdit.FocusControl (opm_Edit_PEditQuantity);
      FNopm_Message (_('The quantity of the product cannot be negative.'), mtWarning, [mbOk], opmG_UISilent);
      ModalResult := mrNone;
    END
  ELSE IF (opm_CurrentPEditRecord.Price < 0) OR ((opm_CurrentPEditRecord.Price = 0) AND (opmG_UIAllowZeroPrice = 0)) THEN
    BEGIN
      opm_PageControl_PEdit.ActivePageIndex := 0;
      opm_Form_PEdit.FocusControl (opm_Edit_PEditPrice);
      FNopm_Message (_('The price of the product is missing.'), mtWarning, [mbOk], opmG_UISilent);
      ModalResult := mrNone;
    END
  ELSE IF (opm_CurrentPEditRecord.CategoryID <= 0) THEN
    BEGIN
      opm_PageControl_PEdit.ActivePageIndex := 0;
      opm_Form_PEdit.FocusControl (opm_ComboBox_PEditCat);
      FNopm_Message (_('The product is not assigned to any category.'), mtWarning, [mbOk], opmG_UISilent);
      ModalResult := mrNone;
    END;
  opm_PEdit_CanClose := TRUE;
END;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_PEdit.FormCreate(Sender: TObject);
begin
  opm_Form_PEdit.Constraints.MinWidth := opmC_MinPWindow_XSize;
  opm_Form_PEdit.Constraints.MinHeight := opmC_MinPWindow_YSize;
  opm_Form_PEdit.Constraints.MaxWidth := opmC_MaxPWindow_XSize;
  opm_Form_PEdit.Constraints.MaxHeight := opmC_MaxPWindow_YSize;
  opm_Form_PEdit.Width := opmC_DefPWindow_XSize;
  opm_Form_PEdit.Height := opmC_DefPWindow_YSize;
  opm_Edit_PEditModel.MaxLength := opmC_ProdModel_MaxLen;
  opm_Edit_PEditPrice.MaxLength := opmC_ProdPrice_MaxLen;
  opm_Edit_PEditSpecial.MaxLength := opmC_ProdSpecial_MaxLen;
  opm_Edit_PEditWeight.MaxLength := opmC_ProdWeight_MaxLen;
  opm_Edit_PEditQuantity.MaxLength := opmC_ProdQuantity_MaxLen;
  opm_Edit_PEditURL.MaxLength := opmC_ProdURL_MaxLen;
  opm_Edit_PEditName.MaxLength := opmC_ProdName_MaxLen;
  opm_Memo_PEditDescription.MaxLength := opmC_ProdDescription_MaxLen;
  opm_DateTimePicker_PEditAvailDate.Date := opmC_Def_PDate;
  opm_DateTimePicker_PEditAvailDate.MaxDate := opmC_Max_PDate;
  opm_DateTimePicker_PEditAvailDate.MinDate := opmC_Min_PDate;
  opm_DateTimePicker_PEditAvailDate.Format := opmC_PDate_Format;
  opm_PEdit_CanZoom := FALSE;
  opm_PEdit_CanClose := TRUE;
  IF (opmG_UIHotTracking > 0) THEN
    BEGIN
      opm_TabControl_PEdit.HotTrack := TRUE;
      opm_PageControl_PEdit.HotTrack := TRUE;
    END
  ELSE
    BEGIN
      opm_TabControl_PEdit.HotTrack := FALSE;
      opm_PageControl_PEdit.HotTrack := FALSE;
    END;
  IF (opmG_UIWBDebug > 0) THEN
    BEGIN
      opm_Memo_UploadDEBUG.Enabled := TRUE;
      opm_Memo_UploadDEBUG.Visible := TRUE;
    END
  ELSE
    BEGIN
      opm_Memo_UploadDEBUG.Enabled := FALSE;
      opm_Memo_UploadDEBUG.Visible := FALSE;
      opm_Memo_UploadDEBUG.Clear;
    END;
  TranslateComponent (self);
  PRballoon_SetFormBalloons (self, opmG_UIToolTips);
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_PEdit.opm_BitBtn_PEditDownClick (Sender: TObject);
BEGIN
  opm_PRSetControls (opm_CurrentImage, opmC_ImageMayExist, TRUE);
  IF (opm_CurrentImage <> '') THEN
    BEGIN
      opm_BitBtn_PEditDown.Enabled := FALSE;
      opm_BitBtn_PEditStopDown.Visible := TRUE;
      opm_BitBtn_PEditStopDown.Enabled := TRUE;
      opm_PRDownload_Image (opm_CurrentImage);
      opm_BitBtn_PEditDown.Enabled := TRUE;
      opm_BitBtn_PEditStopDown.Visible := FALSE;
      opm_BitBtn_PEditStopDown.Enabled := FALSE;
    END;
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_PEdit.opm_BitBtn_PEditStopDownClick(Sender: TObject);
begin
  PRopm_Disconnect_HTTPClient;
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_PEdit.opm_Image_PeditClick(Sender: TObject);
begin
  IF (opm_PEdit_CanZoom = TRUE) THEN
    BEGIN
      PRopm_Sound ('RestoreUp', opmG_UISilent);
      opm_Form_ImageZoom.Show;
    END;
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_PEdit.AutoDownload (var DownloadMsg: TMessage);
begin
  IF (opm_CurrentImage <> '') THEN
    BEGIN
      opm_BitBtn_PEditDown.Enabled := FALSE;
      opm_BitBtn_PEditStopDown.Visible := TRUE;
      opm_BitBtn_PEditStopDown.Enabled := TRUE;
      opm_PRDownload_Image (opm_CurrentImage);
      opm_BitBtn_PEditDown.Enabled := TRUE;
      opm_BitBtn_PEditStopDown.Visible := FALSE;
      opm_BitBtn_PEditStopDown.Enabled := FALSE;
    END;
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_PEdit.opm_PRDownload_Image (ImgURL : STRING);
VAR
  FileStream : TFileStream;
  ImgFileSize : LONGINT;
  StrETA, StrSize : STRING;
BEGIN
  IF (FNopm_Download_File (opmG_WBImgURL + ImgURL, opmG_TMPPath + opmC_TmpImg_Filename) = TRUE) THEN
    TRY
      IF (FNopm_ConvertImage2 (opmG_TMPPath + opmC_TmpImg_Filename, opmG_TMPPath + opmC_TmpBMP_Filename, opmC_BMPFormat, 0) = TRUE) THEN
        BEGIN
          opm_Image_Pedit.Picture.LoadFromFile (opmG_TMPPath + opmC_TmpBMP_Filename);
          opm_Form_ImageZoom.opm_Image_ZoomImage.Picture.LoadFromFile (opmG_TMPPath + opmC_TmpBMP_Filename);
          TRY
            FileStream := TFileStream.Create (opmG_TMPPath + opmC_TmpImg_Filename, fmOpenRead);
            ImgFileSize := FileStream.Size;
          FINALLY
            FileStream.Free;
          END;
          StrSize := INTTOSTR (opm_Image_Pedit.Picture.Width) + 'x' + INTTOSTR (opm_Image_Pedit.Picture.Height) + ', ' + INTTOSTR (ROUND (ImgFileSize / 1024)) + _('k');
          StrETA := INTTOSTR (ROUND (ImgFileSize / (opmC_Def_DownSpeedCalc / 8))) + ' ' + _('secs') + ' @' + FLOATTOSTR (opmC_Def_DownSpeedCalc / 1000) + _('kbps');
          opm_Panel_PeditImage.Hint := ImgURL + balloonC_Balloon_Separator + StrSize + #13#10 + StrETA + #13#10 + #13#10 + _('Click to show full-size image...');
          FNballoon_UpdateBalloon (PCHAR (opm_Panel_PeditImage.Hint), 0, opm_Panel_PeditImage.Handle, opm_Form_PEdit);
          opm_StaticText_PeditImageData.Caption := StrSize;
          opm_StaticText_PeditImageETA.Caption := StrETA;
          opm_Form_ImageZoom.Caption := ImgURL + ' (' + StrSize + ')';
          opm_PRSetControls (opm_CurrentImage, opmC_ImageExists, FALSE);
        END
      ELSE opm_PRSetControls (opm_CurrentImage, opmC_ImageIsCorrupt, TRUE);
    EXCEPT
      opm_PRSetControls (opm_CurrentImage, opmC_ImageDontExist, TRUE);
    END
  ELSE opm_PRSetControls (opm_CurrentImage, opmC_ImageDontExist, TRUE);
END;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_PEdit.opm_BitBtn_PEditDeleteImgClick(Sender: TObject);
VAR
  ResStr : STRING;
begin
  IF (FNopm_Send_Command (opmG_WBUploadURL, 'delete', opm_CurrentImage, ResStr)) THEN
    BEGIN
      opm_PEdit_CanClose := FALSE;
      opm_CurrentImage := '';
      opm_PRSetControls (opm_CurrentImage, opmC_ImageDontExist, TRUE);
    END
  ELSE
    BEGIN
      opm_PRSetControls (opm_CurrentImage, opmC_ImageMayExist, TRUE);
      FNopm_Message (_('There was an error while deleting the file.'), mtError, [mbOk], opmG_UISilent);
    END;
  opm_Memo_UploadDEBUG.Lines.Text := opmG_HTTPClient_TransactLog;
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_PEdit.opm_BitBtn_PEditUploadImgClick (Sender: TObject);
VAR
  ImageJPEG : BOOLEAN;
  ResStr : STRING;
begin
  FNopm_Send_Command (opmG_WBUploadURL, 'listdirs', '', ResStr);
  opm_Memo_UploadDEBUG.Lines.Text := opmG_HTTPClient_TransactLog;
  opm_Form_UploadImage.opm_ComboBox_UploadDir.Items.Text := ResStr;
  IF (opm_Form_UploadImage.opm_ComboBox_UploadDir.Items.Count > 0) THEN
    BEGIN
      opm_Form_UploadImage.opm_ComboBox_UploadDir.Items.Delete (0);
      opm_Form_UploadImage.opm_ComboBox_UploadDir.Items.Delete (opm_Form_UploadImage.opm_ComboBox_UploadDir.Items.Count - 1);
      opm_Form_UploadImage.opm_ComboBox_UploadDir.ItemIndex := 0;
      opm_Form_UploadImage.opm_ComboBox_UploadDir.Text := opmG_Past_PImageDir;
    END
  ELSE opm_Form_UploadImage.opm_ComboBox_UploadDir.Text := '';
  IF (opm_Form_UploadImage.ShowModal = mrOk) THEN
    BEGIN
      opmG_Past_PImageDir := opm_Form_UploadImage.opm_ComboBox_UploadDir.Text;
      IF (opm_Form_UploadImage.opm_RadioGroup_UploadFormat.ItemIndex = 0) THEN ImageJPEG := TRUE ELSE ImageJPEG := FALSE;
      opm_PRPrepareUpload (opm_Form_UploadImage.opm_Edit_UploadFileName.Text, opm_Form_UploadImage.opm_Edit_UploadNewName.Text,
                           opm_Form_UploadImage.opm_ComboBox_UploadDir.Text, ImageJPEG);
      IF (opmG_UIAutoDownImg > 0) THEN PostMessage (Handle, OPM_AUTODOWNLOADIMG, 0, LONGINT (Sender));
    END;
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_PEdit.opm_PRPrepareUpload (ImageFile, NewName, ImgSubdir : STRING; ImageJPEG : BOOLEAN);
VAR
  ConvRes : BOOLEAN;
  ResStr : STRING;
  UploadResult : STRING;
begin
  UploadResult := '';
  opm_PRSetControls (ImageFile, opmC_ImageIsBeingProcessed, TRUE);
  IF ((ImageFile <> '') AND (NewName <> '')) THEN
    BEGIN
      IF ((opm_CurrentImage = '') OR (FNopm_Send_Command (opmG_WBUploadURL, 'delete', opm_CurrentImage, ResStr))) THEN
        BEGIN
          opm_Memo_UploadDEBUG.Lines.Text := opmG_HTTPClient_TransactLog;
          opm_PEdit_CanClose := FALSE;
          Screen.Cursor := opmC_Wait_Mouse;
          IF (opmG_WBResizeImg > 0) THEN
            ConvRes := FNopm_ResizeImage2 (ImageFile, opmG_TMPPath + opmC_TmpBMP_Filename, opmG_WBImgX, opmG_WBImgY, opmG_WBKeepARImg, opmG_WBPaddingImg, opmG_WBPaddingColor)
          ELSE
            ConvRes := FNopm_ConvertImage2 (ImageFile, opmG_TMPPath + opmC_TmpBMP_Filename, opmC_BMPFormat, 0);
          IF (ConvRes = TRUE) THEN
            BEGIN
              IF (ImageJPEG = TRUE) THEN
                BEGIN
                  ImageFile := opmG_TMPPath + opmC_TmpJPG_Filename;
                  ConvRes := FNopm_ConvertImage2 (opmG_TMPPath + opmC_TmpBMP_Filename, ImageFile, opmC_JPEGFormat, opmG_WBImgQ)
                END
              ELSE
                BEGIN
                  ImageFile := opmG_TMPPath + opmC_TmpPNG_Filename;
                  ConvRes := FNopm_ConvertImage2 (opmG_TMPPath + opmC_TmpBMP_Filename, ImageFile, opmC_PNGFormat, 0);
                END;
              IF (ConvRes = TRUE) THEN
                BEGIN
                  FNopm_Upload_File (opmG_WBUploadURL, ImageFile, NewName, ImgSubdir, UploadResult);
                  opm_Memo_UploadDEBUG.Lines.Text := opmG_HTTPClient_TransactLog;
                END;
            END;
          Screen.Cursor := opmC_Normal_Mouse;
          IF (UploadResult <> '') THEN
            BEGIN
              opm_CurrentImage := ExtractFileName (UploadResult);
              opm_PRSetControls (opm_CurrentImage, opmC_ImageMayExist, TRUE);
            END
          ELSE
            BEGIN
              opm_CurrentImage := '';
              opm_PRSetControls (opm_CurrentImage, opmC_ImageDontExist, TRUE);
              FNopm_Message (_('There was an error while uploading the file.'), mtError, [mbOk], opmG_UISilent);
            END;
        END
      ELSE
        BEGIN
          opm_PRSetControls (opm_CurrentImage, opmC_ImageDontExist, TRUE);
          opm_Memo_UploadDEBUG.Lines.Text := opmG_HTTPClient_TransactLog;
        END;
    END
  ELSE opm_PRSetControls (opm_CurrentImage, opmC_ImageDontExist, TRUE);
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_PEdit.FormClose (Sender: TObject; var Action: TCloseAction);
begin
  IF ((opm_CurrentProdRecord.ImageURL <> opm_CurrentImage) AND (opm_PEdit_CanClose = FALSE)) THEN
    BEGIN
      FNopm_Message (_('The product image has been changed but the product record has not been updated.'), mtWarning	, [mbCancel], opmG_UISilent);
      Action := caNone;
    END;
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
PROCEDURE Topm_Form_PEdit.GetDropFiles (var DropingMsg: TWMDropFiles);
VAR
  DropFNames : ARRAY [0..MAX_PATH] of CHAR;
  ResStr : STRING;
  CurFName : STRING;
//  TotalFiles, FileCounter: LONGINT;
BEGIN
//  TotalFiles := DragQueryFile (DropingMsg.Drop, $FFFFFFFF, DropFNames, SizeOf (CurFName));
//  FOR FileCounter := 0 TO (TotalFiles - 1) DO
//    BEGIN
//      CurFName := COPY (DropFNames, 0, DragQueryFile (DropingMsg.Drop, FileCounter, DropFNames, MAX_PATH));
//    END;
  CurFName := COPY (DropFNames, 0, DragQueryFile (DropingMsg.Drop, 0, DropFNames, MAX_PATH));
  DropingMsg.Result := 0;
  DragFinish (DropingMsg.Drop);
  IF (opm_CurrentImage <> '') THEN
    BEGIN
      FNopm_Send_Command (opmG_WBUploadURL, 'delete', opm_CurrentImage, ResStr);
      opm_Memo_UploadDEBUG.Lines.Text := opmG_HTTPClient_TransactLog;
    END;
  opm_PRPrepareUpload (CurFName, ExtractFileName (CurFName), '', TRUE);
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_PEdit.opm_BitBtn_PEditSelectImgClick(Sender: TObject);
VAR
  ResStr : STRING;
begin
  FNopm_Send_Command (opmG_WBUploadURL, 'list', '', ResStr);
  opm_Memo_UploadDEBUG.Lines.Text := opmG_HTTPClient_TransactLog;
  opm_Form_AskUser.AU_DataListText := ResStr;
  IF (opm_Form_AskUser.AU_DataListText <> '') THEN
    BEGIN
      opm_Form_AskUser.AU_PreCleanList := TRUE;
      opm_Form_AskUser.AU_Title := _('Select the image image...');
      opm_Form_AskUser.AU_ListItem := 0;
      opm_Form_AskUser.AU_Directions := _('Select the image for the product:');
      opm_Form_AskUser.AU_TextOrList := FALSE;
      opm_Form_AskUser.AU_PassChar := #0;
      IF (opm_Form_AskUser.ShowModal = mrOk) THEN
        BEGIN
          opm_PEdit_CanClose := FALSE;
          opm_CurrentImage := TRIM (opm_Form_AskUser.AU_DataText);
          opm_PRSetControls (opm_CurrentImage, opmC_ImageExists, TRUE);
        END
      ELSE
        BEGIN
          opm_CurrentImage := '';
          opm_PRSetControls (opm_CurrentImage, opmC_ImageDontExist, TRUE);
        END;
    END
  ELSE
    BEGIN
      FNopm_Message (_('There was an error while getting image files list.'), mtError, [mbOk], opmG_UISilent);
    END;
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_PEdit.opm_PopMenuItem_HideUploadDebugClick (Sender: TObject);
begin
  opmG_UIWBDebug := 0;
  PRReg_WriteSetting ('OSCWBDebug', INTTOSTR (opmG_UIWBDebug), opmC_RegistryKey, opmC_RKConfig);
  opm_Memo_UploadDEBUG.Enabled := FALSE;
  opm_Memo_UploadDEBUG.Visible := FALSE;
  opm_Memo_UploadDEBUG.Clear;
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
FUNCTION Topm_Form_PEdit.opm_FNCleanURL (ProductURL : STRING) : STRING;
BEGIN
  ProductURL := TRIM (ProductURL);
  IF (UPPERCASE (COPY (ProductURL, 1, 7)) = 'HTTP://') THEN ProductURL := COPY (ProductURL, 8, opmC_ProdURL_MaxLen);
  opm_FNCleanURL := ProductURL;
END;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_PEdit.opm_TabControl_PEditChange(Sender: TObject);
begin
  IF (opm_CurrentSingleDescList[opm_TabControl_PEdit.TabIndex].ID > 0) THEN
    BEGIN
      opm_Edit_PEditName.Text := opm_CurrentSingleDescList[opm_TabControl_PEdit.TabIndex].Name;
      opm_Edit_PEditURL.Text := opm_FNCleanURL (opm_CurrentSingleDescList[opm_TabControl_PEdit.TabIndex].URL);
      opm_StaticText_PeditViewed.Caption := INTTOSTR (opm_CurrentSingleDescList[opm_TabControl_PEdit.TabIndex].Viewed);
      opm_Memo_PEditDescription.Lines.Text := opm_CurrentSingleDescList[opm_TabControl_PEdit.TabIndex].Description;
    END
  ELSE
    BEGIN
      opm_CurrentSingleDescList[opm_TabControl_PEdit.TabIndex].ID := opm_CurrentProdRecord.ID;
      opm_CurrentSingleDescList[opm_TabControl_PEdit.TabIndex].LanguageID := opmG_LanguageList[opm_TabControl_PEdit.TabIndex].ID;
      opm_CurrentSingleDescList[opm_TabControl_PEdit.TabIndex].Name := '';
      opm_CurrentSingleDescList[opm_TabControl_PEdit.TabIndex].URL := '';
      opm_CurrentSingleDescList[opm_TabControl_PEdit.TabIndex].Viewed := 0;
      opm_CurrentSingleDescList[opm_TabControl_PEdit.TabIndex].Description := '';
      opm_Edit_PEditName.Text := opm_CurrentSingleDescList[opm_TabControl_PEdit.TabIndex].Name;
      opm_Edit_PEditURL.Text := opm_FNCleanURL (opm_CurrentSingleDescList[opm_TabControl_PEdit.TabIndex].URL);
      opm_StaticText_PeditViewed.Caption := INTTOSTR (opm_CurrentSingleDescList[opm_TabControl_PEdit.TabIndex].Viewed);
      opm_Memo_PEditDescription.Lines.Text := opm_CurrentSingleDescList[opm_TabControl_PEdit.TabIndex].Description;
    END;
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_PEdit.opm_TabControl_PEditChanging(Sender: TObject; var AllowChange: Boolean);
begin
    opm_CurrentSingleDescList[opm_TabControl_PEdit.TabIndex].Name := FNopm_CleanString (opm_Edit_PEditName.Text);
    opm_CurrentSingleDescList[opm_TabControl_PEdit.TabIndex].URL := opm_FNCleanURL (opm_Edit_PEditURL.Text);
    opm_CurrentSingleDescList[opm_TabControl_PEdit.TabIndex].Description := FNopm_CleanString (opm_Memo_PEditDescription.Lines.Text);
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_PEdit.opm_BitBtn_PEditStripHTMLClick(Sender: TObject);
begin
  opm_Edit_PEditName.Text := FNopm_StripHTML (opm_Edit_PEditName.Text);
  opm_Memo_PEditDescription.Lines.Text := FNopm_StripHTML (opm_Memo_PEditDescription.Lines.Text);
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_PEdit.opm_ComboBox_PEditTaxChange(Sender: TObject);
begin
  IF (opm_PEdit_CalcNewTax = TRUE) THEN
    BEGIN
      opm_CurrentTaxRecord := FNopm_GetTax (opmG_TaxList, opm_ComboBox_PEditTax.ItemIndex, opmC_FindByIndex);
      opm_Edit_PEditPriceTaxed.Text := FNopm_AfterTaxPrice (opm_Edit_PEditPrice.Text, opm_CurrentTaxRecord.SumRate);
    END;
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_PEdit.opm_Edit_PEditPriceChange(Sender: TObject);
begin
  IF (opm_PEdit_CalcTaxed = TRUE) THEN
    opm_Edit_PEditPriceTaxed.Text := FNopm_AfterTaxPrice (opm_Edit_PEditPrice.Text, opm_CurrentTaxRecord.SumRate);
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_PEdit.opm_Edit_PEditPriceTaxedChange(Sender: TObject);
begin
  IF (opm_PEdit_CalcUnTaxed = TRUE) THEN
    opm_Edit_PEditPrice.Text := FNopm_BeforeTaxPrice (opm_Edit_PEditPriceTaxed.Text, opm_CurrentTaxRecord.SumRate);
end;



{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_PEdit.opm_Edit_PEditPriceEnter(Sender: TObject);
begin
  opm_PEdit_CalcTaxed := TRUE;
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_PEdit.opm_Edit_PEditPriceExit(Sender: TObject);
begin
  opm_PEdit_CalcTaxed := FALSE;
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_PEdit.opm_Edit_PEditPriceTaxedEnter(Sender: TObject);
begin
  opm_PEdit_CalcUnTaxed := TRUE;
end;

{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
procedure Topm_Form_PEdit.opm_Edit_PEditPriceTaxedExit(Sender: TObject);
begin
  opm_PEdit_CalcUnTaxed := FALSE;
end;


{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
{%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%}
FUNCTION Topm_Form_PEdit.FNopm_GetTax (VAR TaxList : opmT_TaxList; TaxID : LONGINT; SearchBy : INTEGER) : opmR_Tax;
VAR
  CurTaxR : opmR_Tax;
  CurTax : LONGINT;
BEGIN
  CurTaxR.ID := 0;
  CurTaxR.Name := '';
  CurTaxR.ListIndex := 0;
  FNopm_GetTax := CurTaxR;
  IF (SearchBy = opmC_FindByID) THEN
    FOR CurTax := 0 TO (opm_TotalTaxes - 1) DO
      BEGIN
        IF (TaxList[CurTax].ID = TaxID) THEN
          BEGIN
            CurTaxR.ID := TaxList[CurTax].ID;
            CurTaxR.Name := TaxList[CurTax].Name;
            CurTaxR.ListIndex := TaxList[CurTax].ListIndex;
            CurTaxR.SumRate := TaxList[CurTax].SumRate;
            FNopm_GetTax := CurTaxR;
            BREAK;
          END;
      END
  ELSE
    FOR CurTax := 0 TO (opm_TotalTaxes - 1) DO
      BEGIN
        IF (TaxList[CurTax].ListIndex = TaxID) THEN
          BEGIN
            CurTaxR.ID := TaxList[CurTax].ID;
            CurTaxR.Name := TaxList[CurTax].Name;
            CurTaxR.ListIndex := TaxList[CurTax].ListIndex;
            CurTaxR.SumRate := TaxList[CurTax].SumRate;
            FNopm_GetTax := CurTaxR;
            BREAK;
          END;
      END;
END;







end.
